% oprations sur les complexes
% Manuel Luque
% manuel.luque27@gmail.com
% 23/05/2020
/Imul{% produit de 2 nombres complexes
% z1*z2 => z
6 dict begin
/z2 exch def
/z1 exch def
/x1 z1 0 get def
/y1 z1 1 get def
/x2 z2 0 get def
/y2 z2 1 get def
[
x1 x2 mul y1 y2 mul sub
x1 y2 mul x2 y1 mul add
]
end
} def
/Iabs{% module d'un complexe
3 dict begin
/z exch def
/x z 0 get def
/y z 1 get def
x dup mul y dup mul add sqrt
end
} def
/Iadd { % addition de 2 complexes
% z1*z2 => z
6 dict begin
/z2 exch def
/z1 exch def
/x1 z1 0 get def
/y1 z1 1 get def
/x2 z2 0 get def
/y2 z2 1 get def
[x1 x2 add  y1 y2 add]
end
} def
/Irmul {% multiplier un complexe par un rel
2 dict begin
/z exch def
/r exch def
[z {r mul} forall]
end
} def
/ReZ { % partie relle
 0 get
} def
/ImZ { % partie imaginaire
 1 get
} def
%en complexes
/ChebyshevT {
3 dict begin
/T0 [1 0] def
/z exch def
/n exch def
/T1 z def
n 0 eq n 1 eq or {
n 0 eq {T0} if
n 1 eq {T1} if}{
n 1 sub {
/T2 2 z Irmul T1 Imul -1 T0 Irmul Iadd def
/T0 T1 def
/T1 T2 def
} repeat
T2}
ifelse
end
} def
/ChebyshevU { 
3 dict begin
/U0 [1 0] def
/z exch def
/n exch def
/U1 2 z Irmul def
n 0 eq n 1 eq or {
n 0 eq {U0} if
n 1 eq {U1} if}{
n 1 sub {
/U2 2 z Irmul U1 Imul -1 U0 Irmul Iadd def
/U0 U1 def
/U1 U2 def
} repeat
U2} 
ifelse
end
} def
/Euler 2.71828182846 def 
/Pi 3.14159265359 def

/ComplexExponentiation {
6 dict begin
/d exch def
/c exch def
/b exch def
/a exch def
/alpha b a atan def
alpha 180 gt {/alpha alpha 360 sub def} if
/Arg alpha 180 div Pi mul def % radian
/ab a dup mul b dup mul add sqrt def
/module ab c exp Euler d neg Arg mul exp mul def
module c Arg mul d ab ln mul add 180 mul Pi div cos mul % x
module c Arg mul d ab ln mul add 180 mul Pi div sin mul % y
end
} def
% a b c d ComplexExponentiation -> x y
/ComplexExp {
% multiply a complex by a real
% z n ComplexExp -> z^n
% x y n ComplexExp -> z^n
5 dict begin
/n exch def
/y exch def
/x exch def
/module x dup mul y dup mul add  def
/Arg y x atan def % 
module n 2 div exp n Arg mul cos mul % x
module n 2 div exp n Arg mul sin mul % y
end
} def
%
%% z n alpha Gegenbauer -> z'
%% alpha complexe
/GegenbauerC {
7 dict begin
/alpha exch def
/n exch def
/z exch def
/alphaR alpha 0 get def
/alphaI alpha 1 get def
/compteur 2 def
/C0 [1 0] def
/C1 alpha 2 z Irmul Imul def
n 1 sub { 
/C2 1 compteur div 
    2 z Irmul 
    [compteur alphaR add 1 sub alphaI] Imul 
    C1 Imul 
    [compteur 2 alphaR mul add 2 sub neg -2 alphaI mul] C0 Imul 
    Iadd Irmul 
    def
/C0 C1 def
/C1 C2 def
/compteur compteur 1 add def
}repeat
C1
end
} def

%% z n alpha Gegenbauer -> z'
%% alpha rel
/Gegenbauer {
7 dict begin
/alpha exch def
/n exch def
n 2 lt {/n 2 def} if
/z exch def
% /compteur 1 def
/compteur 2 def
/C0 [1 0] def
/C1 2 alpha mul z Irmul def
n 1 sub { 
/C2 1 compteur div 
    2 z Irmul 
    compteur alpha add 1 sub exch Irmul 
    C1 Imul 
    compteur 2 alpha mul add 2 sub neg C0 Irmul 
    Iadd Irmul 
    def
/C0 C1 def
/C1 C2 def
/compteur compteur 1 add def
}repeat
C1
end
} def
%
/Legendre {
%%  x n Legendre -> x'
5 dict begin
/n exch def
/x exch def
/P0 1 def
/P1 x def
n 1 le {
 n 0 eq {/P1 1 def} if
 n 1 eq {/P1 x def} if
 }{
/m 1 def
n 1 sub
 {
 /P2 2 m mul 1 add P1 mul x mul m P0 mul sub m 1 add div def
 /P0 P1 def
 /P1 P2 def
/m m 1 add def
} repeat
} ifelse
P1
end
} def

% z n LegendreP -> z'
 /LegendreP {
%%  z n LegendreP -> z'
6 dict begin
/n exch def
/z exch def
/P0 [1 0] def
/P1 z def
n 2 le {
 n 1 eq {/P1 P0 def} {/P1 z def}ifelse
 }{
/m 1 def
n 1 sub
 {
 /P2 1 m 1 add div 
     2 m mul 1 add P1 Irmul z Imul m neg P0 Irmul Iadd Irmul def
 /P0 P1 def
 /P1 P2 def
/m m 1 add def
} repeat
} ifelse
P1
end
} def
